unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, ExtCtrls, Grids, DBGrids, DB, DBTables, StdCtrls,
  dxExEdtr, dxDBTLCl, dxGrClms, dxTL, dxDBCtrl, dxDBGrid, dxCntner, dxGridMenus,
  Buttons, shellapi, ActnList, Menus, ComCtrls, registry, TNShellNotifyIcon;

type
  TformMenuPrincipal = class(TForm)
    DB: TDataSource;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel1: TPanel;
    bdNavegador: TDBNavigator;
    Splitter2: TSplitter;
    Tabla: TTable;
    TablaNombreApellidos: TStringField;
    TablaTelefonoParticular: TStringField;
    TablaTelefonoOficina: TStringField;
    TablaTelefonoMovil: TStringField;
    TablaTelefonoParticular2: TStringField;
    TablaTelefonoOficina2: TStringField;
    TablaTelefonoMovil2: TStringField;
    TablaFax: TStringField;
    TablaFax2: TStringField;
    TablaEMail: TStringField;
    TablaWeb: TStringField;
    TablaDireccion: TStringField;
    TablaPoblacion: TStringField;
    TablaProvincia: TStringField;
    TablaPais: TStringField;
    TablaObservacion: TStringField;
    TablaFoto: TGraphicField;
    txtBuscar: TEdit;
    opNombre: TRadioButton;
    opTelefonoPart: TRadioButton;
    opTelefonoMovil: TRadioButton;
    TTabla: TdxDBGrid;
    TTablaNombreApellidos: TdxDBGridMaskColumn;
    TTablaTelefonoParticular: TdxDBGridMaskColumn;
    TTablaTelefonoOficina: TdxDBGridMaskColumn;
    TTablaTelefonoMovil: TdxDBGridMaskColumn;
    TTablaTelefonoParticular2: TdxDBGridMaskColumn;
    TTablaTelefonoOficina2: TdxDBGridMaskColumn;
    TTablaTelefonoMovil2: TdxDBGridMaskColumn;
    TTablaFax: TdxDBGridMaskColumn;
    TTablaFax2: TdxDBGridMaskColumn;
    TTablaEMail: TdxDBGridMaskColumn;
    TTablaWeb: TdxDBGridMaskColumn;
    TTablaDireccion: TdxDBGridMaskColumn;
    TTablaPoblacion: TdxDBGridMaskColumn;
    TTablaProvincia: TdxDBGridMaskColumn;
    TTablaPais: TdxDBGridMaskColumn;
    TTablaObservacion: TdxDBGridMaskColumn;
    TTablaFoto: TdxDBGridGraphicColumn;
    dgGuardar: TSaveDialog;
    BBuscar: TButton;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    actBuscar: TAction;
    actTablaBusqueda: TAction;
    Opciones1: TMenuItem;
    ablamodobsqueda1: TMenuItem;
    actExportarExcel: TAction;
    ExportaraExcel1: TMenuItem;
    Panel3: TPanel;
    StatusBar1: TStatusBar;
    LWEB: TLabel;
    actMinimizar: TAction;
    iconizar: TTNShellNotifyIcon;
    pMenu: TPopupMenu;
    actMostrar: TAction;
    Minimizar1: TMenuItem;
    Minimizar2: TMenuItem;
    N1: TMenuItem;
    actEjecutarMinimizada: TAction;
    actCerrar: TAction;
    N2: TMenuItem;
    Salir1: TMenuItem;
    N3: TMenuItem;
    Salir2: TMenuItem;
    Ejecutarminimizada1: TMenuItem;
    procedure TTablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TablaAfterPost(DataSet: TDataSet);
    procedure FormShow(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure TablaAfterInsert(DataSet: TDataSet);
    procedure txtBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure actBuscarExecute(Sender: TObject);
    procedure actTablaBusquedaExecute(Sender: TObject);
    procedure actExportarExcelExecute(Sender: TObject);
    procedure actMinimizarExecute(Sender: TObject);
    procedure actMostrarExecute(Sender: TObject);
    procedure iconizarDblClick(Sender: TObject; Button: TMouseButton);
    procedure actCerrarExecute(Sender: TObject);
    procedure actEjecutarMinimizadaExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.TTablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformMenuPrincipal.TablaAfterPost(DataSet: TDataSet);
begin
  Tabla.FlushBuffers;
end;

procedure TformMenuPrincipal.FormShow(Sender: TObject);
begin
  Tabla.Close;
  Tabla.DatabaseName := ExtractFilePath(Application.ExeName);
  Tabla.Open;
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.TablaAfterInsert(DataSet: TDataSet);
begin
  TTabla.SetFocus;
end;

procedure TformMenuPrincipal.txtBuscarKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
    actBuscarExecute(nil);
end;

procedure TformMenuPrincipal.actBuscarExecute(Sender: TObject);
begin
  if opNombre.Checked then
    if not Tabla.Locate('NombreApellidos', txtBuscar.Text, [loCaseInsensitive, loPartialKey]) then
      MessageDlg('No se ha encontrado ninguna persona/empresa con ese nombre.', mtInformation, [mbok], 0);
  if opTelefonoPart.Checked then
    if not Tabla.Locate('TelefonoParticular', txtBuscar.Text, [loCaseInsensitive, loPartialKey]) then
      MessageDlg('No se ha encontrado ninguna persona/empresa con ese telfono particular.', mtInformation, [mbok], 0);
  if opTelefonoMovil.Checked then
    if not Tabla.Locate('TelefonoMovil', txtBuscar.Text, [loCaseInsensitive, loPartialKey]) then
      MessageDlg('No se ha encontrado ninguna persona/empresa con ese telfono mvil.', mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.actTablaBusquedaExecute(Sender: TObject);
var
  opciones : TdxDBGridOptionsBehavior;
  opciones2 : TdxDBGridOptionsDB;
begin
  if actTablaBusqueda.Checked then
  begin
    opciones := [edgoAutoSort,edgoBandButtonClicking,edgoDragScroll,edgoEditing,edgoEnterShowEditor,edgoImmediateEditor,edgoMouseScroll,edgoMultiSort,edgoShowHourGlass,edgoStoreToIniFile,edgoTabs,edgoTabThrough,edgoVertThrough];
    TTabla.OptionsBehavior := opciones;
    opciones2 := [edgoCancelOnExit,edgoCanDelete,edgoCanInsert,edgoCanNavigation,edgoConfirmDelete,edgoLoadAllRecords,edgoUseBookmarks];
    TTabla.OptionsDB := opciones2;
    actTablaBusqueda.Checked := false;
    bdNavegador.Enabled := true;

  end
  else
  begin
    opciones := [edgoAutoSearch, edgoAutoSort,edgoBandButtonClicking,edgoDragScroll,edgoMouseScroll,edgoMultiSort,edgoShowHourGlass,edgoStoreToIniFile,edgoTabs,edgoTabThrough,edgoVertThrough];
    TTabla.OptionsBehavior := opciones;
    opciones2 := [edgouselocate,edgoCanNavigation,edgoLoadAllRecords,edgoUseBookmarks];
    actTablaBusqueda.Checked := true;
    bdNavegador.Enabled := false;
  end;
end;

procedure TformMenuPrincipal.actExportarExcelExecute(Sender: TObject);
begin
  if dgGuardar.Execute then
    TTabla.SaveToXLS(dgGuardar.FileName,true);
end;

procedure TformMenuPrincipal.actMinimizarExecute(Sender: TObject);
begin
  Hide;
  Application.ShowMainForm := False;
  iconizar.Hint := 'AjpdSoft Agenda';
  iconizar.Active := true;
end;

procedure TformMenuPrincipal.actMostrarExecute(Sender: TObject);
begin
  iconizar.Active := false;
  Show;
end;

procedure TformMenuPrincipal.iconizarDblClick(Sender: TObject;
  Button: TMouseButton);
begin
  actMostrarExecute(nil);
end;

procedure TformMenuPrincipal.actCerrarExecute(Sender: TObject);
begin
  Close;
end;

procedure TformMenuPrincipal.actEjecutarMinimizadaExecute(Sender: TObject);
var
  reg : tregistry;
begin
  actEjecutarMinimizada.Checked := not actEjecutarMinimizada.Checked;
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey('\SOFTWARE\AjpdSoft\Agenda', true);
    Reg.WriteBool('Ejecutar minimizada', actEjecutarMinimizada.Checked);
  finally
    Reg.free;
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  reg : tregistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey('\SOFTWARE\AjpdSoft\Agenda', false);
    actEjecutarMinimizada.Checked := Reg.ReadBool('Ejecutar minimizada');
    if actEjecutarMinimizada.Checked then
      actMinimizarExecute(nil);
  finally
    reg.Free;
  end;
end;

end.
